// chip content
NUTOOL_CLOCK.g_cfg_chips = [
	//NANO100AN
	{ name: "NANO100ZC2AN", pkg: "QFN33" },
	{ name: "NANO100ZD2AN", pkg: "QFN33" },
	{ name: "NANO100ZD3AN", pkg: "QFN33" },
	{ name: "NANO100LC2AN", pkg: "LQFP48" },
	{ name: "NANO100LD2AN", pkg: "LQFP48" },
	{ name: "NANO100LD3AN", pkg: "LQFP48" },
	{ name: "NANO100SC2AN", pkg: "LQFP64" },
	{ name: "NANO100SD2AN", pkg: "LQFP64" },
	{ name: "NANO100SD3AN", pkg: "LQFP64" },
	{ name: "NANO100VD2AN", pkg: "LQFP100" },
	{ name: "NANO100VD3AN", pkg: "LQFP100" },

	{ name: "NANO120ZC2AN", pkg: "QFN33" },
	{ name: "NANO120ZD2AN", pkg: "QFN33" },
	{ name: "NANO120ZD3AN", pkg: "QFN33" },
	{ name: "NANO120LC2AN", pkg: "LQFP48" },
	{ name: "NANO120LD2AN", pkg: "LQFP48" },
	{ name: "NANO120LD3AN", pkg: "LQFP48" },
	{ name: "NANO120SC2AN", pkg: "LQFP64" },
	{ name: "NANO120SD2AN", pkg: "LQFP64" },
	{ name: "NANO120SD3AN", pkg: "LQFP64" },
	{ name: "NANO120VD2AN", pkg: "LQFP100" },
	{ name: "NANO120VD3AN", pkg: "LQFP100" },
	//NANO100BN
	{ name: "NANO100NC2BN", pkg: "QFN48" },
	{ name: "NANO100ND2BN", pkg: "QFN48" },
	{ name: "NANO100ND3BN", pkg: "QFN48" },
	{ name: "NANO100NE3BN", pkg: "QFN48" },
	{ name: "NANO100LC2BN", pkg: "LQFP48" },
	{ name: "NANO100LD2BN", pkg: "LQFP48" },
	{ name: "NANO100LD3BN", pkg: "LQFP48" },
	{ name: "NANO100LE3BN", pkg: "LQFP48" },
	{ name: "NANO100SC2BN", pkg: "LQFP64" },
	{ name: "NANO100SD2BN", pkg: "LQFP64" },
	{ name: "NANO100SD3BN", pkg: "LQFP64" },
	{ name: "NANO100SE3BN", pkg: "LQFP64" },
	{ name: "NANO100KD3BN", pkg: "LQFP128" },
	{ name: "NANO100KC2BN", pkg: "LQFP128" },
	{ name: "NANO100KD2BN", pkg: "LQFP128" },
	{ name: "NANO100KC3BN", pkg: "LQFP128" },
	{ name: "NANO100KE3BN", pkg: "LQFP128" },

	{ name: "NANO110SC2BN", pkg: "LQFP64" },
	{ name: "NANO110SD2BN", pkg: "LQFP64" },
	{ name: "NANO110SD3BN", pkg: "LQFP64" },
	{ name: "NANO110SE3BN", pkg: "LQFP64" },
	{ name: "NANO110RC2BN", pkg: "LQFP64" },
	{ name: "NANO110RD2BN", pkg: "LQFP64" },
	{ name: "NANO110RD3BN", pkg: "LQFP64" },
	{ name: "NANO110RE3BN", pkg: "LQFP64" },
	{ name: "NANO110KC2BN", pkg: "LQFP128" },
	{ name: "NANO110KD2BN", pkg: "LQFP128" },
	{ name: "NANO110KD3BN", pkg: "LQFP128" },
	{ name: "NANO110KE3BN", pkg: "LQFP128" },

	{ name: "NANO120LC2BN", pkg: "LQFP48" },
	{ name: "NANO120LD2BN", pkg: "LQFP48" },
	{ name: "NANO120LD3BN", pkg: "LQFP48" },
	{ name: "NANO120LE3BN", pkg: "LQFP48" },
	{ name: "NANO120SC2BN", pkg: "LQFP64" },
	{ name: "NANO120SD2BN", pkg: "LQFP64" },
	{ name: "NANO120SD3BN", pkg: "LQFP64" },
	{ name: "NANO120SE3BN", pkg: "LQFP64" },
	{ name: "NANO120KC2BN", pkg: "LQFP128" },
	{ name: "NANO120KD2BN", pkg: "LQFP128" },
	{ name: "NANO120KD3BN", pkg: "LQFP128" },
	{ name: "NANO120KE3BN", pkg: "LQFP128" },

	{ name: "NANO130SC2BN", pkg: "LQFP64" },
	{ name: "NANO130SD2BN", pkg: "LQFP64" },
	{ name: "NANO130SD3BN", pkg: "LQFP64" },
	{ name: "NANO130SE3BN", pkg: "LQFP64" },
	{ name: "NANO130KC2BN", pkg: "LQFP128" },
	{ name: "NANO130KD2BN", pkg: "LQFP128" },
	{ name: "NANO130KD3BN", pkg: "LQFP128" },
	{ name: "NANO130KE3BN", pkg: "LQFP128" },
	//NANO103
	{ name: "NANO103SD3AE", pkg: "LQFP64" },
	{ name: "NANO103LD3AE", pkg: "LQFP48" },
	{ name: "NANO103ZD3AE", pkg: "QFN33" },
	//NANO112
	{ name: "NANO112VC2AN", pkg: "LQFP100" },
	{ name: "NANO112RC2AN", pkg: "LQFP64" },
	{ name: "NANO112RB1AN", pkg: "LQFP64" },
	{ name: "NANO112SC2AN", pkg: "LQFP64" },
	{ name: "NANO112SB1AN", pkg: "LQFP64" },
	{ name: "NANO102SC2AN", pkg: "LQFP64" },
	{ name: "NANO112LC2AN", pkg: "LQFP48" },
	{ name: "NANO112LB1AN", pkg: "LQFP48" },
	{ name: "NANO102LC2AN", pkg: "LQFP48" },
	{ name: "NANO102LB1AN", pkg: "LQFP48" },
	{ name: "NANO102ZB1AN", pkg: "QFN33" },
	{ name: "NANO102ZC2AN", pkg: "QFN33" }
];

NUTOOL_CLOCK.g_register_map = [];
NUTOOL_CLOCK.g_register_map.PWRCTL = ['OSC10K_EN:3', 'OSC22M_EN:2', 'XTL32K_EN:1', 'XTL12M_EN:0', 'HIRC_FSEL:12'];
NUTOOL_CLOCK.g_register_map.AHBCLK = ['TICK_EN:5', 'SRAM_EN:4', 'ISP_EN:2', 'DMA_EN:1', 'GPIO_EN:0'];
NUTOOL_CLOCK.g_register_map.APBCLK = ['SC1_EN:31', 'SC0_EN:30', 'ADC_EN:28', 'LCD_EN:26', 'PWM0_CH23_EN:21', 'PWM0_CH01_EN:20', 'UART1_EN:17', 'UART0_EN:16', 'SPI1_EN:13', 'SPI0_EN:12', 'ACMP_EN:11', 'I2C1_EN:9', 'I2C0_EN:8', 'FDIV1_EN:7', 'FDIV0_EN:6', 'TMR3_EN:5', 'TMR2_EN:4', 'TMR1_EN:3', 'TMR0_EN:2', 'RTC_EN:1', 'WDT_EN:0'];
NUTOOL_CLOCK.g_register_map.CLKSEL0 = ['HCLK_S:2-0'];
NUTOOL_CLOCK.g_register_map.CLKSEL1 = ['ADC_S:21-19', 'TMR1_S:14-12', 'TMR0_S:10-8', 'PWM0_CH23_S:7-6', 'PWM0_CH01_S:5-4', 'UART_S:1-0'];
NUTOOL_CLOCK.g_register_map.CLKSEL2 = ['SPI1_S:21', 'SPI0_S:20', 'SC_S:19-18', 'TMR3_S:14-12', 'TMR2_S:10-8', 'FRQDIV0_S:3-2', 'FRQDIV1_S:1-0'];
NUTOOL_CLOCK.g_register_map.CLKDIV0 = ['SC0_N:31-28', 'ADC_N:23-16', 'UART_N:11-8', 'HCLK_N:3-0'];
NUTOOL_CLOCK.g_register_map.CLKDIV1 = ['TMR3_N:23-20', 'TMR2_N:19-16', 'TMR1_N:15-12', 'TMR0_N:11-8', 'SC1_N:3-0'];
NUTOOL_CLOCK.g_register_map.PLLCTL = ['PLL_SRC:17', 'PD:16', 'PLL_SRC_N:11-8', 'PLL_MLP:5-0'];
NUTOOL_CLOCK.g_register_map.FRQDIV0 = ['DIV10:5', 'DIVIDER0_EN:4', 'FSEL0:3-0'];
NUTOOL_CLOCK.g_register_map.FRQDIV1 = ['DIV11:5', 'DIVIDER1_EN:4', 'FSEL1:3-0'];
NUTOOL_CLOCK.g_register_map.APB_DIV = ['APBDIV:2-0'];
NUTOOL_CLOCK.g_register_map.SYST_CTL = ['CLKSRC:2', 'ENABLE:0'];

// Be careful.The order of g_register_map_default will affect the result in the generated code.
NUTOOL_CLOCK.g_register_map_default = [];
NUTOOL_CLOCK.g_register_map_default.CLKDIV0  = '0x00000000';
NUTOOL_CLOCK.g_register_map_default.CLKDIV1  = '0x00000000';
NUTOOL_CLOCK.g_register_map_default.APB_DIV  = '0x00000000';
NUTOOL_CLOCK.g_register_map_default.CLKSEL0  = '0x00000007';
NUTOOL_CLOCK.g_register_map_default.CLKSEL1  = '0x001844F3';
NUTOOL_CLOCK.g_register_map_default.CLKSEL2  = '0x0038440F';
NUTOOL_CLOCK.g_register_map_default.PWRCTL   = '0x001A0B1F';
NUTOOL_CLOCK.g_register_map_default.AHBCLK   = '0x00000035';
NUTOOL_CLOCK.g_register_map_default.APBCLK   = '0x00000001';
NUTOOL_CLOCK.g_register_map_default.PLLCTL   = '0x00030000';
NUTOOL_CLOCK.g_register_map_default.FRQDIV0  = '0x00000000';
NUTOOL_CLOCK.g_register_map_default.FRQDIV1  = '0x00000000';
NUTOOL_CLOCK.g_register_map_default.SYST_CTL = '0x00000004';

NUTOOL_CLOCK.g_register_map_description = [];
NUTOOL_CLOCK.g_register_map_description.PWRCTL   = '0x50000200';
NUTOOL_CLOCK.g_register_map_description.AHBCLK   = '0x50000204';
NUTOOL_CLOCK.g_register_map_description.APBCLK   = '0x50000208';
NUTOOL_CLOCK.g_register_map_description.CLKSEL0  = '0x50000210';
NUTOOL_CLOCK.g_register_map_description.CLKSEL1  = '0x50000214';
NUTOOL_CLOCK.g_register_map_description.CLKSEL2  = '0x50000218';
NUTOOL_CLOCK.g_register_map_description.CLKDIV0  = '0x5000021C';
NUTOOL_CLOCK.g_register_map_description.CLKDIV1  = '0x50000220';
NUTOOL_CLOCK.g_register_map_description.PLLCTL   = '0x50000224';
NUTOOL_CLOCK.g_register_map_description.FRQDIV0  = '0x50000228';
NUTOOL_CLOCK.g_register_map_description.FRQDIV1  = '0x50000238';
NUTOOL_CLOCK.g_register_map_description.APB_DIV  = '0x50000234';
NUTOOL_CLOCK.g_register_map_description.SYST_CTL = '0xE000E010';

NUTOOL_CLOCK.g_CLKSEL = [];
NUTOOL_CLOCK.g_CLKSEL.ADC_S = ['HXT:0', 'LXT:1', 'PLL:2', 'HIRC:3', 'HCLK:7'];
NUTOOL_CLOCK.g_CLKSEL.FRQDIV0_S = ['HXT:0', 'LXT:1', 'HCLK:2', 'HIRC:3'];
NUTOOL_CLOCK.g_CLKSEL.FRQDIV1_S = ['HXT:0', 'LXT:1', 'HCLK:2', 'HIRC:3'];
NUTOOL_CLOCK.g_CLKSEL.HCLK_S = ['HXT:0', 'LXT:1', 'PLL:2', 'LIRC:3', 'HIRC:7'];
NUTOOL_CLOCK.g_CLKSEL.PWM0_CH01_S = ['HXT:0', 'LXT:1', 'HCLK:2', 'HIRC:3'];
NUTOOL_CLOCK.g_CLKSEL.PWM0_CH23_S = ['HXT:0', 'LXT:1', 'HCLK:2', 'HIRC:3'];
NUTOOL_CLOCK.g_CLKSEL.SC_S = ['HXT:0', 'PLL:1', 'HIRC:2', 'HCLK:3'];
NUTOOL_CLOCK.g_CLKSEL.SPI0_S = ['PLL:0', 'HCLK:1'];
NUTOOL_CLOCK.g_CLKSEL.SPI1_S = ['PLL:0', 'HCLK:1'];
NUTOOL_CLOCK.g_CLKSEL.TMR0_S = ['HXT:0', 'LXT:1', 'LIRC:2', 'HIRC:4', 'HCLK:7']; //'external:3'
NUTOOL_CLOCK.g_CLKSEL.TMR1_S = ['HXT:0', 'LXT:1', 'LIRC:2', 'HIRC:4', 'HCLK:7']; //'external:3'
NUTOOL_CLOCK.g_CLKSEL.TMR2_S = ['HXT:0', 'LXT:1', 'LIRC:2', 'HIRC:4', 'HCLK:7']; //'external:3'
NUTOOL_CLOCK.g_CLKSEL.TMR3_S = ['HXT:0', 'LXT:1', 'LIRC:2', 'HIRC:4', 'HCLK:7']; //'external:3'
NUTOOL_CLOCK.g_CLKSEL.UART_S = ['HXT:0', 'LXT:1', 'PLL:2', 'HIRC:3'];
NUTOOL_CLOCK.g_CLKSEL.APBDIV = ['HCLK:0', 'HCLK/2:1', 'HCLK/4:2', 'HCLK/8:3', 'HCLK/16:4'];

NUTOOL_CLOCK.g_CLKSEL_EXTENDED = [];

// Be careful.The order of g_register_map_default will affect the result in the generated code.
NUTOOL_CLOCK.g_Module = [];
NUTOOL_CLOCK.g_Module.ACMP = ['PCLK', 'ACMP_EN', 'none'];
NUTOOL_CLOCK.g_Module.ADC = ['ADC_S', 'ADC_EN', 'ADC_N'];
NUTOOL_CLOCK.g_Module.CLK0 = ['FRQDIV0_S', 'FDIV0_EN/DIVIDER0_EN/DIV10', 'none'];
NUTOOL_CLOCK.g_Module.CLK0_Divider = ['FRQDIV0_S', 'FDIV0_EN/DIVIDER0_EN/!DIV10', 'FSEL0'];
NUTOOL_CLOCK.g_Module.CLK1 = ['FRQDIV1_S', 'FDIV1_EN/DIVIDER1_EN/DIV11', 'none'];
NUTOOL_CLOCK.g_Module.CLK1_Divider = ['FRQDIV1_S', 'FDIV1_EN/DIVIDER1_EN/!DIV11', 'FSEL1'];
NUTOOL_CLOCK.g_Module.DMA = ['HCLK', 'DMA_EN', 'none'];
NUTOOL_CLOCK.g_Module.GPIO = ['HCLK', 'GPIO_EN', 'none'];
NUTOOL_CLOCK.g_Module.I2C0 = ['PCLK', 'I2C0_EN', 'none'];
NUTOOL_CLOCK.g_Module.I2C1 = ['PCLK', 'I2C1_EN', 'none'];
NUTOOL_CLOCK.g_Module.ISP = ['HIRC', 'ISP_EN', 'none'];
NUTOOL_CLOCK.g_Module.LCD = ['LXT', 'LCD_EN', 'none'];
NUTOOL_CLOCK.g_Module.PWM0_CH01 = ['PWM0_CH01_S', 'PWM0_CH01_EN', 'none'];
NUTOOL_CLOCK.g_Module.PWM0_CH23 = ['PWM0_CH23_S', 'PWM0_CH23_EN', 'none'];
NUTOOL_CLOCK.g_Module.RTC = ['LXT', 'RTC_EN', 'none'];
NUTOOL_CLOCK.g_Module.SC0 = ['SC_S', 'SC0_EN', 'SC0_N'];
NUTOOL_CLOCK.g_Module.SC1 = ['SC_S', 'SC1_EN', 'SC1_N'];
NUTOOL_CLOCK.g_Module.SPI0 = ['SPI0_S', 'SPI0_EN', 'none'];
NUTOOL_CLOCK.g_Module.SPI1 = ['SPI1_S', 'SPI1_EN', 'none'];
NUTOOL_CLOCK.g_Module.SRAM = ['HCLK', 'SRAM_EN', 'none'];
NUTOOL_CLOCK.g_Module.TICK = ['HCLK', 'TICK_EN', 'none'];
NUTOOL_CLOCK.g_Module.TMR0 = ['TMR0_S', 'TMR0_EN', 'TMR0_N'];
NUTOOL_CLOCK.g_Module.TMR1 = ['TMR1_S', 'TMR1_EN', 'TMR1_N'];
NUTOOL_CLOCK.g_Module.TMR2 = ['TMR2_S', 'TMR2_EN', 'TMR2_N'];
NUTOOL_CLOCK.g_Module.TMR3 = ['TMR3_S', 'TMR3_EN', 'TMR3_N'];
NUTOOL_CLOCK.g_Module.UART0 = ['UART_S', 'UART0_EN', 'UART_N'];
NUTOOL_CLOCK.g_Module.UART1 = ['UART_S', 'UART1_EN', 'UART_N'];
NUTOOL_CLOCK.g_Module.WDT = ['LIRC', 'WDT_EN', 'none'];
NUTOOL_CLOCK.g_Module.WWDT = ['HCLK/2048', 'WDT_EN', 'none'];
NUTOOL_CLOCK.g_Module.SYSTICK = ['HCLK/8', 'ENABLE', 'none']; // Selector implicitly includes SYST_CTL[2]

NUTOOL_CLOCK.g_unusedModule = {};
NUTOOL_CLOCK.g_equivalentName = [];
NUTOOL_CLOCK.g_equivalentName.CLKO = 'CLK0';
NUTOOL_CLOCK.g_equivalentName.CLKO_Divider = 'CLK0_Divider';
NUTOOL_CLOCK.g_equivalentName.CLKO1 = 'CLK1';
NUTOOL_CLOCK.g_equivalentName.CLKO1_Divider = 'CLK1_Divider';
NUTOOL_CLOCK.g_equivalentName.SYST_CSR = 'SYST_CTL';
NUTOOL_CLOCK.g_equivalentName.PCLK_S = 'APBDIV';
NUTOOL_CLOCK.g_equivalentName.PWRCON = 'PWRCTL';
NUTOOL_CLOCK.g_equivalentName.PLLCON = 'PLLCTL';

NUTOOL_CLOCK.g_BusFromPCLK1 = [];
NUTOOL_CLOCK.g_DIV_Module_Defines = ['USB:USB', 'UART:UART'];
NUTOOL_CLOCK.g_CPUCLKLimit = 32 * 1000000;
NUTOOL_CLOCK.g_HIRCfrequencyArray = [12 * 1000000, 16 * 1000000];
NUTOOL_CLOCK.g_HIRCfrequency = 12 * 1000000;
NUTOOL_CLOCK.g_LIRCfrequency = 10 * 1000;
NUTOOL_CLOCK.g_MIRCfrequency = 0;
NUTOOL_CLOCK.g_RTC32kfrequency = 0;
NUTOOL_CLOCK.g_PLL480Mfrequency = 0;